structure Model = 
struct

open Real
open Math
open RungeKutta

datatype ('b,'c) trs = TRSA of 'b | TRSB of 'c
datatype ('a,'b,'c) trc = TRC of ((('a -> (('b,'c) trs))) * 
                                  (('a -> (('b,'c) trs))) * 
                                  ((('b,'c) trs) -> bool))
	 
fun tsCase (fa,fb,x) = case x of TRSA a => (fa a) | TRSB b => (fb b)
fun trfOf x = case x of TRC (f,fk,e) => f
fun trfkOf x = case x of TRC (f,fk,e) => fk
fun treOf x = case x of TRC (f,fk,e) => e

fun putStrLn str = 
  (TextIO.output (TextIO.stdOut, str);
   TextIO.output (TextIO.stdOut, "\n"))

fun putStr str = (TextIO.output (TextIO.stdOut, str))

fun showReal n = 
let open StringCvt
in
(if n < 0.0 then "-" else "") ^ (fmt (FIX (SOME 12)) (abs n))
end

exception EmptySignal
val neg = (op ~)
val swap = fn (x,v) => (case v of NONE => x | SOME v => v) 
val equal = fn (x,y) => (x = y) 
val signalOf = fn (v) => (case v of NONE => raise EmptySignal | SOME v => v) 
val summer = fn (a,b) => (ListPair.map (fn (x,y) => x+y) (a,b))
val scaler = fn(a,lst) => (map (fn (x) => a*x) lst)
val rkfe: (real list) stepper1 = make_rkfe()
fun make_stepper (deriv) = rkfe (scaler,summer,deriv)
fun integrate (f,x: real,y: real list,h,i) = ((make_stepper f) h) (x,y)
val trstm176 = (TRC((fn (t,h,V,R,Isyn,tau,spike,tau_syn,W,theta,tspike,Vreset,tau_rp,rpend,rpstate) => let 
val Vprime158 = (fn (tau,Isyn,R,V) => ((op /)(((op +)((neg V),((op *)(R,Isyn)))),tau)))
val dfn161 = (fn (t,yvec) => let 
val V = List.nth (yvec, 0)

in 
([(Vprime158(tau,Isyn,R,V))])
end
)
val integral159 = (integrate(dfn161,t,([V]),h,1))
val integral160 = {V_t_h155_156 = List.nth (integral159, 0)}
val actuate180 = {V = (#V_t_h155_156(integral160))}
val sf162 = (fn (h,t) => ((op +)(t,h)))
val rv181 = (sf162(h,t))
val rv182 = {sf162 = rv181}
val actuate183 = {t = (#sf162(rv182))}
val union179 = {t = (#t(actuate183)), V = (#V(actuate180))}
val sf163 = (fn (theta,V) => ((op >=)(V,theta)))
val rv185 = (sf163(theta,(#V(union179))))
val rv186 = {sf163 = rv185}
val actuate187 = {spike = (#sf163(rv186))}
val sf164 = (fn (tspike,t,spike) => (if (spike) then t else tspike))
val rv188 = (sf164(tspike,(#t(union179)),(#spike(actuate187))))
val rv189 = {sf164 = rv188}
val actuate190 = {tspike = (#sf164(rv189))}
val sequence191 = {spike = (#spike(actuate187)), tspike = (#tspike(actuate190))}
val sf165 = false
val rv193 = {sf165 = sf165}
val actuate194 = {rpend = (#sf165(rv193))}
val union184 = {rpend = (#rpend(actuate194)), tspike = (#tspike(actuate190)), spike = (#spike(actuate187))}
val sequence195 = {V = (#V(union179)), t = (#t(union179)), spike = (#spike(union184)), tspike = (#tspike(union184)), rpend = (#rpend(union184))}

in 
(TRSA {t = (#t(union179)), V = (#V(union179)), spike = (#spike(union184)), tspike = (#tspike(union184)), rpend = (#rpend(union184))})
end
),(fn (t,h,V,R,Isyn,tau,spike,tau_syn,W,theta,tspike,Vreset,tau_rp,rpend,rpstate) => let 
val sf166 = (fn (Vreset) => Vreset)
val rv197 = (sf166 Vreset)
val rv198 = {sf166 = rv197}
val actuate199 = {V = (#sf166(rv198))}
val sf167 = false
val rv201 = {sf167 = sf167}
val actuate202 = {spike = (#sf167(rv201))}
val sf168 = (fn (tspike) => tspike)
val rv203 = (sf168 tspike)
val rv204 = {sf168 = rv203}
val actuate205 = {tspike = (#sf168(rv204))}
val sf169 = (fn (tau_rp,tspike,t) => ((op >=)(t,((op +)(tspike,tau_rp)))))
val rv206 = (sf169(tau_rp,tspike,t))
val rv207 = {sf169 = rv206}
val actuate208 = {rpend = (#sf169(rv207))}
val sf170 = (fn (h,t) => ((op +)(t,h)))
val rv209 = (sf170(h,t))
val rv210 = {sf170 = rv209}
val actuate211 = {t = (#sf170(rv210))}
val union196 = {t = (#t(actuate211)), tspike = (#tspike(actuate205)), rpend = (#rpend(actuate208)), V = (#V(actuate199)), spike = (#spike(actuate202))}

in 
(TRSB {spike = (#spike(union196)), V = (#V(union196)), rpend = (#rpend(union196)), tspike = (#tspike(union196)), t = (#t(union196))})
end
),(fn (x) => (tsCase((fn (x) => (#spike(x))),(fn (x) => (#rpend(x))),x)))))
val blender178 = (fn (trstm176,t,h,V,R,Isyn,tau,spike,tau_syn,W,theta,tspike,Vreset,tau_rp,rpend,rpstate) => let 
val f = (trfOf trstm176)
val fk = (trfkOf trstm176)
val e = (treOf trstm176)
val fv = (if (rpstate) then (fk(t,h,V,R,Isyn,tau,spike,tau_syn,W,theta,tspike,Vreset,tau_rp,rpend,rpstate)) else (f(t,h,V,R,Isyn,tau,spike,tau_syn,W,theta,tspike,Vreset,tau_rp,rpend,rpstate)))
val trp = (e fv)
val rpstate = (if (trp) then (not rpstate) else rpstate)

in 
if ((not trp)) 
then (if (rpstate) then (tsCase((fn (x) => {rpstate = rpstate, rpend = (#rpend(x)), tspike = (#tspike(x)), spike = (#spike(x)), V = (#V(x)), t = (#t(x))}),(fn (x) => {rpstate = rpstate, rpend = (#rpend(x)), tspike = (#tspike(x)), spike = (#spike(x)), V = (#V(x)), t = (#t(x))}),fv)) else (tsCase((fn (x) => {rpstate = rpstate, rpend = (#rpend(x)), tspike = (#tspike(x)), spike = (#spike(x)), V = (#V(x)), t = (#t(x))}),(fn (x) => {rpstate = rpstate, rpend = (#rpend(x)), tspike = (#tspike(x)), spike = (#spike(x)), V = (#V(x)), t = (#t(x))}),fv)))
else if (rpstate) 
then (tsCase((fn (x) => {rpstate = rpstate, rpend = (#rpend(x)), tspike = (#tspike(x)), spike = (#spike(x)), V = (#V(x)), t = (#t(x))}),(fn (x) => {rpstate = rpstate, rpend = (#rpend(x)), tspike = (#tspike(x)), spike = (#spike(x)), V = (#V(x)), t = (#t(x))}),fv))
else (tsCase((fn (x) => {rpstate = rpstate, rpend = (#rpend(x)), tspike = (#tspike(x)), spike = (#spike(x)), V = (#V(x)), t = (#t(x))}),(fn (x) => {rpstate = rpstate, rpend = (#rpend(x)), tspike = (#tspike(x)), spike = (#spike(x)), V = (#V(x)), t = (#t(x))}),fv))


end
)

fun TestBrunelIaFalphaivp146(input as {rpstate,rpend,tau_rp,Vreset,tspike,theta,spike,tau,R,V,W,Isyn,tau_syn,h,t}) = 
let
val Isynprime150 = (fn (tau_syn,Isyn,W) => ((op /)(((op -)(W,Isyn)),tau_syn)))
val dfn153 = (fn (t,yvec) => let 
val Isyn = List.nth (yvec, 0)

in 
([(Isynprime150((#tau_syn(input)),Isyn,(#W(input))))])
end
)
val integral151 = (integrate(dfn153,(#t(input)),([(#Isyn(input))]),(#h(input)),0))
val integral152 = {Isyn_t_h147_148 = List.nth (integral151, 0)}
val actuate172 = {Isyn = (#Isyn_t_h147_148(integral152))}
val sf154 = (fn (h,t) => ((op +)(t,h)))
val rv173 = (sf154((#h(input)),(#t(input))))
val rv174 = {sf154 = rv173}
val actuate175 = {t = (#sf154(rv174))}
val union171 = {t = (#t(actuate175)), Isyn = (#Isyn(actuate172))}
val trv177 = (blender178(trstm176,(#t(union171)),(#h(input)),(#V(input)),(#R(input)),(#Isyn(union171)),(#tau(input)),(#spike(input)),(#tau_syn(input)),(#W(input)),(#theta(input)),(#tspike(input)),(#Vreset(input)),(#tau_rp(input)),(#rpend(input)),(#rpstate(input))))
val sequence212 = {Isyn = (#Isyn(union171)), t = (#t(trv177)), V = (#V(trv177)), spike = (#spike(trv177)), tspike = (#tspike(trv177)), rpend = (#rpend(trv177)), rpstate = (#rpstate(trv177))}

in
sequence212
end
end
