structure Model = 
struct

open Real
open Math
open RungeKutta

datatype ('b,'c) trs = TRSA of 'b | TRSB of 'c
datatype ('a,'b,'c) trc = TRC of ((('a -> (('b,'c) trs))) * 
                                  (('a -> (('b,'c) trs))) * 
                                  ((('b,'c) trs) -> bool))
	 
fun tsCase (fa,fb,x) = case x of TRSA a => (fa a) | TRSB b => (fb b)
fun trfOf x = case x of TRC (f,fk,e) => f
fun trfkOf x = case x of TRC (f,fk,e) => fk
fun treOf x = case x of TRC (f,fk,e) => e

fun putStrLn str = 
  (TextIO.output (TextIO.stdOut, str);
   TextIO.output (TextIO.stdOut, "\n"))

fun putStr str = (TextIO.output (TextIO.stdOut, str))

fun showReal n = 
let open StringCvt
in
(if n < 0.0 then "-" else "") ^ (fmt (FIX (SOME 12)) (abs n))
end

exception EmptySignal
val neg = (op ~)
val swap = fn (x,v) => (case v of NONE => x | SOME v => v) 
val equal = fn (x,y) => (x = y) 
val signalOf = fn (v) => (case v of NONE => raise EmptySignal | SOME v => v) 
val summer = fn (a,b) => (ListPair.map (fn (x,y) => x+y) (a,b))
val scaler = fn(a,lst) => (map (fn (x) => a*x) lst)
val rkfe: (real list) stepper1 = make_rkfe()
fun make_stepper (deriv) = rkfe (scaler,summer,deriv)
fun integrate (f,x: real,y: real list,h,i) = ((make_stepper f) h) (x,y)
val trstm161 = (TRC((fn (t,h,V,R,Isyn,tau,spike,tspike,theta,rpend,Vreset,tau_rp,rpstate) => let 
val Vprime150 = (fn (tau,Isyn,R,V) => ((op /)(((op +)((neg V),((op *)(R,Isyn)))),tau)))
val dfn153 = (fn (t,yvec) => let 
val V = List.nth (yvec, 0)
in 
([(Vprime150(tau,Isyn,R,V))])
end
)
val integral151 = (integrate(dfn153,t,([V]),h,0))
val integral152 = {V_t_h147_148 = List.nth (integral151, 0)}
val actuate165 = {V = (#V_t_h147_148(integral152))}
val sf154 = (fn (h,t) => ((op +)(t,h)))
val rv166 = (sf154(h,t))
val rv167 = {sf154 = rv166}
val actuate168 = {t = (#sf154(rv167))}
val union164 = {sf154 = (#sf154(rv167)), t = (#t(actuate168)), V = (#V(actuate165)), V_t_h147_148 = (#V_t_h147_148(integral152))}
val sf155 = (fn (theta,V) => ((op >=)(V,theta)))
val rv169 = (sf155(theta,(#V(union164))))
val rv170 = {sf155 = rv169}
val actuate171 = {spike = (#sf155(rv170))}
val sf156 = (fn (tspike,t,spike) => (if (spike) then t else tspike))
val rv172 = (sf156(tspike,(#t(union164)),(#spike(actuate171))))
val rv173 = {sf156 = rv172}
val actuate174 = {tspike = (#sf156(rv173))}
val sequence175 = {spike = (#spike(actuate171)), sf155 = (#sf155(rv170)), tspike = (#tspike(actuate174)), sf156 = (#sf156(rv173))}
val sequence176 = {V_t_h147_148 = (#V_t_h147_148(union164)), V = (#V(union164)), t = (#t(union164)), sf154 = (#sf154(union164)), sf156 = (#sf156(rv173)), tspike = (#tspike(actuate174)), spike = (#spike(actuate171)), sf155 = (#sf155(rv170))}

in 
(TRSA {sf154 = (#sf154(union164)), t = (#t(union164)), V = (#V(union164)), V_t_h147_148 = (#V_t_h147_148(union164)), sf156 = (#sf156(rv173)), tspike = (#tspike(actuate174)), spike = (#spike(actuate171)), sf155 = (#sf155(rv170))})
end
),(fn (t,h,V,R,Isyn,tau,spike,tspike,theta,rpend,Vreset,tau_rp,rpstate) => let 
val sf157 = (fn (Vreset) => Vreset)
val rv178 = (sf157 Vreset)
val rv179 = {sf157 = rv178}
val actuate180 = {V = (#sf157(rv179))}
val sf158 = false
val rv182 = {sf158 = sf158}
val actuate183 = {spike = (#sf158(rv182))}
val sf159 = (fn (tau_rp,tspike,t) => ((op >=)(t,((op +)(tspike,tau_rp)))))
val rv184 = (sf159(tau_rp,tspike,t))
val rv185 = {sf159 = rv184}
val actuate186 = {rpend = (#sf159(rv185))}
val sf160 = (fn (h,t) => ((op +)(t,h)))
val rv187 = (sf160(h,t))
val rv188 = {sf160 = rv187}
val actuate189 = {t = (#sf160(rv188))}
val union177 = {sf160 = (#sf160(rv188)), t = (#t(actuate189)), rpend = (#rpend(actuate186)), sf159 = (#sf159(rv185)), sf157 = (#sf157(rv179)), V = (#V(actuate180)), spike = (#spike(actuate183)), sf158 = (#sf158(rv182))}

in 
(TRSB {sf158 = (#sf158(union177)), spike = (#spike(union177)), V = (#V(union177)), sf157 = (#sf157(union177)), sf159 = (#sf159(union177)), rpend = (#rpend(union177)), t = (#t(union177)), sf160 = (#sf160(union177))})
end
),(fn (x) => (tsCase((fn (x) => (#spike(x))),(fn (x) => (#rpend(x))),x)))))
val blender163 = (fn (trstm161,t,h,V,R,Isyn,tau,spike,tspike,theta,rpend,Vreset,tau_rp,rpstate) => let 
val f = (trfOf trstm161)
val fk = (trfkOf trstm161)
val e = (treOf trstm161)
val fv = (if (rpstate) then (fk(t,h,V,R,Isyn,tau,spike,tspike,theta,rpend,Vreset,tau_rp,rpstate)) else (f(t,h,V,R,Isyn,tau,spike,tspike,theta,rpend,Vreset,tau_rp,rpstate)))
val trp = (e fv)
val rpstate = (if (trp) then (not rpstate) else rpstate)

in 
if ((not trp)) 
then (if (rpstate) then (tsCase((fn (x) => {rpstate = rpstate, spike = (#spike(x)), V = (#V(x)), t = (#t(x)), tspike = (#tspike(x)), rpend = rpend}),(fn (x) => {rpstate = rpstate, spike = (#spike(x)), V = (#V(x)), t = (#t(x)), rpend = (#rpend(x)), tspike = tspike}),fv)) else (tsCase((fn (x) => {rpstate = rpstate, spike = (#spike(x)), V = (#V(x)), t = (#t(x)), rpend = rpend, tspike = tspike}),(fn (x) => {rpstate = rpstate, spike = (#spike(x)), V = (#V(x)), t = (#t(x)), rpend = rpend, tspike = tspike}),fv)))
else if (rpstate) 
then (tsCase((fn (x) => {rpstate = rpstate, spike = (#spike(x)), V = (#V(x)), t = (#t(x)), tspike = (#tspike(x)), rpend = rpend}),(fn (x) => {rpstate = rpstate, spike = (#spike(x)), V = (#V(x)), t = (#t(x)), rpend = (#rpend(x)), tspike = tspike}),fv))
else (tsCase((fn (x) => {rpstate = rpstate, spike = (#spike(x)), V = (#V(x)), t = (#t(x)), rpend = rpend, tspike = tspike}),(fn (x) => {rpstate = rpstate, spike = (#spike(x)), V = (#V(x)), t = (#t(x)), rpend = rpend, tspike = tspike}),fv))


end
)

fun TestBrunelIaFdeltaivp146(input as {t,h,V,R,Isyn,tau,spike,tspike,theta,Vreset,tau_rp,rpend,rpstate}) = 
let
val trv162 = (blender163(trstm161,(#t(input)),(#h(input)),(#V(input)),(#R(input)),(#Isyn(input)),(#tau(input)),(#spike(input)),(#tspike(input)),(#theta(input)),(#rpend(input)),(#Vreset(input)),(#tau_rp(input)),(#rpstate(input))))

in
trv162
end
end
